/*********************************************************/
/* M A K E L I S T . c p p                               */
/*                                                       */
/* Hangman Word List Creator                             */
/* Version 2.1                                           */
/*                                                       */
/* Hangman and this source were both programmed by       */
/* Geoff Lywood aka KrYpT                                */
/* glywood@yahoo.com                                     */
/* ICQ: 117312247                                        */
/*                                                       */
/* This is the source for the hangman word list creator. */
/* Your may use any of this code for your own use as     */
/* long as you give me some credit. You may not          */
/* distribute a modified version without my permission.  */
/*                                                       */
/* Compiled using Borland C++ Compiler 5.5               */
/*                                                       */
/*********************************************************/

#include <fstream.h>
#include <iostream.h>
#include <string.h>

#define ptr1 0x35      //Offset from right after header to end of data.
#define ptr2 0x37      //Offset from right after header to end of vat entry.
#define ptr3 0x39      //Size of file after beginning of data. (includes 2 end bytes)
#define ptr4 0x44      //Version?
#define ptr5 0x46      //Offset to two end bytes.
#define ptr6 0x48      //Program length.
#define ptrVAT 0x3B    //Beginning of VAT entry (the $06)
#define ptrData 0x4A   //Begin data

int main(int argc,char *argv[]) {
	
	unsigned short count=0,sum=0,tempptr,temp;
	char buffer[80],buf[80],name[9]={0,0,0,0,0,0,0,0,0},b,lines=0;
	char header[53] = "**TI83F*\x1A\x0A\0Word list for Hangman v2.0 by KrYpT";
	unsigned char cc;
	short a,len,ptrEnd,ptrCount;
	ifstream in;
	fstream out;
	
	cout << "\nHangman Word List Creator v2.1\n";
	cout << "Copyright 2002 by Geoff Lywood.\n\n";
	cout << "Usage:\n";
	cout << "   makelist infile.txt outfile\n";
	
	if (argc != 3) return 1;
	in.open(argv[1]);
	strcpy(name,strupr(argv[2]));
	out.open(strcat(argv[2],".8xp"), ios::out | ios::binary | ios::trunc | ios::in);
	
	out.write(header,53);
	out.seekp(ptrData,SEEK_SET);
	
	cout << "\nPlease enter the name for this wordlist: ";
	strcpy(buffer,"Hg1GL");
	cin.getline(buffer+5,75);
	out << buffer;
	out << (char)0 << (char)1;
	ptrCount = out.tellp();
	out << (char)0 << (char)0;
	count = 4+strlen(buffer);
	
	while (!in.eof()) {
		in.getline(buf,80);
		strcpy(buffer+1,strupr(buf));
		len = strlen(buffer+1);
		if (len==0) continue;
		if ((buffer[1]=='/')&&(buffer[2]=='/')) continue;
		lines++;
		count+=len+2;
		b=0;
		for (a=0;a<len;a++) {
			if (buffer[a+1]==' ') {
				buffer[a+1]=0;
				b++;
			}
		}
		buffer[0]=b+1;
		buffer[len+1]=0;
		out.write(buffer,len+2);
	}
	ptrEnd = out.tellp();
	out.seekp(ptrCount);
	out.write(&lines,1);
	out.seekp(ptr1);
	out.write((char*)&(tempptr=count+ptrData-ptr1-2),sizeof(short));
	out.seekp(ptr2);
	out.write((char*)&(tempptr=0x0D),sizeof(short));
	out.seekp(ptr3);
	out.write((char*)&(tempptr=count+2),sizeof(short));
	out.seekp(ptr4);
	out.write((char*)&(tempptr=0),sizeof(short));
	out.seekp(ptr5);
	out.write((char*)&(tempptr=count+2),sizeof(short));
	out.seekp(ptr6);
	out.write((char*)&count,sizeof(short));
	out.seekp(ptrVAT);
	strcpy(buf+1,name);
	buf[0]=6;
	for (a=strlen(buf);a<=9;a++) buf[a] = 0;
	out.write(buf,9);
	out.seekg(ptr2);
	while (out.tellg()<ptrEnd) {
		out.read(&cc,1);
		sum+=(unsigned short)cc;
	}
	out.seekp(ptrEnd);
	out.write((char*)&sum,sizeof(short));
	cout << "\nSuccess!\n";
	
	return 0;
	
}